using ldap_cesi.Entities;
using ldap_cesi.Models;
using ldap_cesi.Repository.Services;
using ldap_cesi.Services.Interfaces;

namespace ldap_cesi.Services;

public class SalarieService : ISalarieService
{
    private IRepositorySalarie _repositorySalarie;

    public SalarieService(IRepositorySalarie repositorySalarie)
    {
        _repositorySalarie = repositorySalarie;
    }
    
    public async Task<IResponseDataModel<List<Salarie>>> GetAll()
    {
        var salaries = await _repositorySalarie.GetAllAsync();
        return new ResponseDataModel<List<Salarie>>
        {
            Success = true,
            Data = salaries,
            StatusCode = 200,
        };
    }    
    
    public async Task<IResponseDataModel<Salarie>> GetById(int id)
    {
        var service = await _repositorySalarie.GetByIdAsync(id);
        return new ResponseDataModel<Salarie>
        {
            Success = true,
            Data = service,
            StatusCode = 200,
        };
    }
}